package pl.poznan.put.erepodevel;

import com.openkm.ws.client.AccessDeniedException_Exception;
import com.openkm.ws.client.BytePair;
import com.openkm.ws.client.BytePairArray;
import com.openkm.ws.client.DatabaseException_Exception;
import com.openkm.ws.client.OKMAuth;
import com.openkm.ws.client.OKMAuthService;
import com.openkm.ws.client.PathNotFoundException_Exception;
import com.openkm.ws.client.PrincipalAdapterException_Exception;
import com.openkm.ws.client.RepositoryException_Exception;
import com.openkm.ws.client.StringArray;

public class OKMAuthMethods {

	private String sessionId;
	private OKMAuth okmAuth;

	public OKMAuthMethods() {

	}

	public StringArray getUsers() throws PrincipalAdapterException_Exception {
		StringArray userList = okmAuth.getUsers(getSessionId());
		for (String s : userList.getItem())
			System.out.println("" + s);
		return userList;
	}

	public StringArray getRoles() throws PrincipalAdapterException_Exception {
		StringArray roleList = okmAuth.getRoles(getSessionId());
		for (String s : roleList.getItem())
			System.out.println("" + s);
		return roleList;
	}

	// void grantUser(String token, String nodePath, String user, int
	// permissions, boolean recursive)
	public void grantUser(String path, String user, int permissions)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {

		okmAuth.grantUser(getSessionId(), path, user, permissions, false);

		// check if grant to node is done

	}

	public void revokeUser(String path, String user, int permissions)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {

		okmAuth.revokeUser(getSessionId(), path, user, permissions, false);

		// check if revoke role to node is done
	}

	public BytePairArray getGrantedUsers(String path)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {

		BytePairArray roleList = okmAuth.getGrantedUsers(getSessionId(), path);
		for (BytePair s : roleList.getItem())
			System.out.println("k: " + s.getKey() + "\nv: " + s.getValue());
		return roleList;
	}

	// Grant role permissions for a node.
	public void grantRole(String path, String role, int permissions)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {

		okmAuth.grantRole(getSessionId(), path, role, permissions, false);

		// check

	}

	public void revokeRole(String path, String role, int permissions)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {

		okmAuth.revokeRole(getSessionId(), path, role, permissions, false);

		// check

	}

	public BytePairArray getGrantedRoles(String path)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {

		BytePairArray roleList = okmAuth.getGrantedRoles(getSessionId(), path);
		//System.out.println("getGrantedRoles");
		for (BytePair s : roleList.getItem())
			System.out.println("k: " + s.getKey() + "\nv: " + s.getValue());
		return roleList;
	}

	public void login(String username, String password)
			throws AccessDeniedException_Exception,
			RepositoryException_Exception, DatabaseException_Exception {
		OKMAuthService okmAuthService = new OKMAuthService();
		okmAuth = okmAuthService.getOKMAuthPort();
		setSessionId(okmAuth.login(username, password));
		System.out.println("Session id: " + getSessionId());
	}

	public void logout() throws AccessDeniedException_Exception,
			RepositoryException_Exception, DatabaseException_Exception {
		okmAuth.logout(getSessionId());
	}

	private void setSessionId(String sessionId) {
		this.sessionId = sessionId;
	}

	public String getSessionId() {
		return sessionId;
	}
}
