package pl.poznan.put.erepodevel;

import com.openkm.ws.client.AccessDeniedException_Exception;
import com.openkm.ws.client.DatabaseException_Exception;
import com.openkm.ws.client.FormElementArray;
import com.openkm.ws.client.FormElementComplexArray;
import com.openkm.ws.client.IOException_Exception;
import com.openkm.ws.client.LockException_Exception;
import com.openkm.ws.client.NoSuchGroupException_Exception;
import com.openkm.ws.client.NoSuchPropertyException_Exception;
import com.openkm.ws.client.OKMPropertyGroup;
import com.openkm.ws.client.OKMPropertyGroupService;
import com.openkm.ws.client.ParseException_Exception;
import com.openkm.ws.client.PathNotFoundException_Exception;
import com.openkm.ws.client.PropertyGroupArray;
import com.openkm.ws.client.RepositoryException_Exception;

public class OKMPropertyGroupMethods {

	private OKMPropertyGroup okmPropertyGroup;

	public OKMPropertyGroupMethods() {
		OKMPropertyGroupService okmPropertyGroupService = new OKMPropertyGroupService();
		okmPropertyGroup = okmPropertyGroupService.getOKMPropertyGroupPort();
	}

	public void addGroup(String token, String nodePath, String grpName)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, LockException_Exception,
			NoSuchGroupException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {
		okmPropertyGroup.addGroup(token, nodePath, grpName);
	}

	public PropertyGroupArray getAllGroups(String token)
			throws DatabaseException_Exception, IOException_Exception,
			ParseException_Exception, RepositoryException_Exception {
		PropertyGroupArray p = okmPropertyGroup.getAllGroups(token);
		return p;
	}

	public PropertyGroupArray getGroups(String token, String nodePath)
			throws DatabaseException_Exception, IOException_Exception,
			ParseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {
		PropertyGroupArray p = okmPropertyGroup.getGroups(token, nodePath);
		return p;
	}

	public FormElementComplexArray getProperties(String token, String nodePath,
			String grpName) throws DatabaseException_Exception,
			IOException_Exception, NoSuchGroupException_Exception,
			ParseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {
		FormElementComplexArray f = okmPropertyGroup.getProperties(token, nodePath,
				grpName);
		return f;
	}

	public void removeGroup(String token, String nodePath, String grpName)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, LockException_Exception,
			NoSuchGroupException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {
		okmPropertyGroup.removeGroup(token, nodePath, grpName);
	}

	public void setProperties(String token, String nodePath, String grpName,
			FormElementComplexArray properties)
			throws AccessDeniedException_Exception,
			DatabaseException_Exception, IOException_Exception,
			LockException_Exception, NoSuchGroupException_Exception,
			NoSuchPropertyException_Exception, ParseException_Exception,
			PathNotFoundException_Exception, RepositoryException_Exception {
		okmPropertyGroup.setProperties(token, nodePath, grpName, properties);
	}

	public boolean hasGroup(String token, String nodePath, String grpName)
			throws DatabaseException_Exception, IOException_Exception,
			ParseException_Exception, PathNotFoundException_Exception,
			RepositoryException_Exception {
		boolean temp = okmPropertyGroup.hasGroup(token, nodePath, grpName);
		return temp;
	}

}
